/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { EntityModelTransportCall } from '../model';
// @ts-ignore
import { PagedModelEntityModelTransportCall } from '../model';
// @ts-ignore
import { TransportCallRequestBody } from '../model';
/**
 * TransportCallEntityControllerApi - axios parameter creator
 * @export
 */
export const TransportCallEntityControllerApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * delete-transportcall
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteItemResourceTransportcallDelete: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteItemResourceTransportcallDelete', 'id', id)
            const localVarPath = `/transportCalls/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * get-transportcall
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCollectionResourceTransportcallGet1: async (page?: number, size?: number, sort?: Array<string>, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/transportCalls`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }

            if (sort) {
                localVarQueryParameter['sort'] = sort;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * get-transportcall
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getItemResourceTransportcallGet: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getItemResourceTransportcallGet', 'id', id)
            const localVarPath = `/transportCalls/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * patch-transportcall
         * @param {string} id 
         * @param {TransportCallRequestBody} transportCallRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchItemResourceTransportcallPatch: async (id: string, transportCallRequestBody: TransportCallRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('patchItemResourceTransportcallPatch', 'id', id)
            // verify required parameter 'transportCallRequestBody' is not null or undefined
            assertParamExists('patchItemResourceTransportcallPatch', 'transportCallRequestBody', transportCallRequestBody)
            const localVarPath = `/transportCalls/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(transportCallRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * create-transportcall
         * @param {TransportCallRequestBody} transportCallRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postCollectionResourceTransportcallPost: async (transportCallRequestBody: TransportCallRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'transportCallRequestBody' is not null or undefined
            assertParamExists('postCollectionResourceTransportcallPost', 'transportCallRequestBody', transportCallRequestBody)
            const localVarPath = `/transportCalls`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(transportCallRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * update-transportcall
         * @param {string} id 
         * @param {TransportCallRequestBody} transportCallRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        putItemResourceTransportcallPut: async (id: string, transportCallRequestBody: TransportCallRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('putItemResourceTransportcallPut', 'id', id)
            // verify required parameter 'transportCallRequestBody' is not null or undefined
            assertParamExists('putItemResourceTransportcallPut', 'transportCallRequestBody', transportCallRequestBody)
            const localVarPath = `/transportCalls/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(transportCallRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TransportCallEntityControllerApi - functional programming interface
 * @export
 */
export const TransportCallEntityControllerApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = TransportCallEntityControllerApiAxiosParamCreator(configuration)
    return {
        /**
         * delete-transportcall
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteItemResourceTransportcallDelete(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteItemResourceTransportcallDelete(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * get-transportcall
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getCollectionResourceTransportcallGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PagedModelEntityModelTransportCall>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getCollectionResourceTransportcallGet1(page, size, sort, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * get-transportcall
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getItemResourceTransportcallGet(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelTransportCall>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getItemResourceTransportcallGet(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * patch-transportcall
         * @param {string} id 
         * @param {TransportCallRequestBody} transportCallRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async patchItemResourceTransportcallPatch(id: string, transportCallRequestBody: TransportCallRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelTransportCall>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.patchItemResourceTransportcallPatch(id, transportCallRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * create-transportcall
         * @param {TransportCallRequestBody} transportCallRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async postCollectionResourceTransportcallPost(transportCallRequestBody: TransportCallRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelTransportCall>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.postCollectionResourceTransportcallPost(transportCallRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * update-transportcall
         * @param {string} id 
         * @param {TransportCallRequestBody} transportCallRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async putItemResourceTransportcallPut(id: string, transportCallRequestBody: TransportCallRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelTransportCall>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.putItemResourceTransportcallPut(id, transportCallRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * TransportCallEntityControllerApi - factory interface
 * @export
 */
export const TransportCallEntityControllerApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = TransportCallEntityControllerApiFp(configuration)
    return {
        /**
         * delete-transportcall
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteItemResourceTransportcallDelete(id: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteItemResourceTransportcallDelete(id, options).then((request) => request(axios, basePath));
        },
        /**
         * get-transportcall
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCollectionResourceTransportcallGet1(page?: number, size?: number, sort?: Array<string>, options?: any): AxiosPromise<PagedModelEntityModelTransportCall> {
            return localVarFp.getCollectionResourceTransportcallGet1(page, size, sort, options).then((request) => request(axios, basePath));
        },
        /**
         * get-transportcall
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getItemResourceTransportcallGet(id: string, options?: any): AxiosPromise<EntityModelTransportCall> {
            return localVarFp.getItemResourceTransportcallGet(id, options).then((request) => request(axios, basePath));
        },
        /**
         * patch-transportcall
         * @param {string} id 
         * @param {TransportCallRequestBody} transportCallRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchItemResourceTransportcallPatch(id: string, transportCallRequestBody: TransportCallRequestBody, options?: any): AxiosPromise<EntityModelTransportCall> {
            return localVarFp.patchItemResourceTransportcallPatch(id, transportCallRequestBody, options).then((request) => request(axios, basePath));
        },
        /**
         * create-transportcall
         * @param {TransportCallRequestBody} transportCallRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postCollectionResourceTransportcallPost(transportCallRequestBody: TransportCallRequestBody, options?: any): AxiosPromise<EntityModelTransportCall> {
            return localVarFp.postCollectionResourceTransportcallPost(transportCallRequestBody, options).then((request) => request(axios, basePath));
        },
        /**
         * update-transportcall
         * @param {string} id 
         * @param {TransportCallRequestBody} transportCallRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        putItemResourceTransportcallPut(id: string, transportCallRequestBody: TransportCallRequestBody, options?: any): AxiosPromise<EntityModelTransportCall> {
            return localVarFp.putItemResourceTransportcallPut(id, transportCallRequestBody, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TransportCallEntityControllerApi - interface
 * @export
 * @interface TransportCallEntityControllerApi
 */
export interface TransportCallEntityControllerApiInterface {
    /**
     * delete-transportcall
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApiInterface
     */
    deleteItemResourceTransportcallDelete(id: string, options?: AxiosRequestConfig): AxiosPromise<void>;

    /**
     * get-transportcall
     * @param {number} [page] Zero-based page index (0..N)
     * @param {number} [size] The size of the page to be returned
     * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApiInterface
     */
    getCollectionResourceTransportcallGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig): AxiosPromise<PagedModelEntityModelTransportCall>;

    /**
     * get-transportcall
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApiInterface
     */
    getItemResourceTransportcallGet(id: string, options?: AxiosRequestConfig): AxiosPromise<EntityModelTransportCall>;

    /**
     * patch-transportcall
     * @param {string} id 
     * @param {TransportCallRequestBody} transportCallRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApiInterface
     */
    patchItemResourceTransportcallPatch(id: string, transportCallRequestBody: TransportCallRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelTransportCall>;

    /**
     * create-transportcall
     * @param {TransportCallRequestBody} transportCallRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApiInterface
     */
    postCollectionResourceTransportcallPost(transportCallRequestBody: TransportCallRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelTransportCall>;

    /**
     * update-transportcall
     * @param {string} id 
     * @param {TransportCallRequestBody} transportCallRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApiInterface
     */
    putItemResourceTransportcallPut(id: string, transportCallRequestBody: TransportCallRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelTransportCall>;

}

/**
 * TransportCallEntityControllerApi - object-oriented interface
 * @export
 * @class TransportCallEntityControllerApi
 * @extends {BaseAPI}
 */
export class TransportCallEntityControllerApi extends BaseAPI implements TransportCallEntityControllerApiInterface {
    /**
     * delete-transportcall
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApi
     */
    public deleteItemResourceTransportcallDelete(id: string, options?: AxiosRequestConfig) {
        return TransportCallEntityControllerApiFp(this.configuration).deleteItemResourceTransportcallDelete(id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * get-transportcall
     * @param {number} [page] Zero-based page index (0..N)
     * @param {number} [size] The size of the page to be returned
     * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApi
     */
    public getCollectionResourceTransportcallGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig) {
        return TransportCallEntityControllerApiFp(this.configuration).getCollectionResourceTransportcallGet1(page, size, sort, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * get-transportcall
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApi
     */
    public getItemResourceTransportcallGet(id: string, options?: AxiosRequestConfig) {
        return TransportCallEntityControllerApiFp(this.configuration).getItemResourceTransportcallGet(id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * patch-transportcall
     * @param {string} id 
     * @param {TransportCallRequestBody} transportCallRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApi
     */
    public patchItemResourceTransportcallPatch(id: string, transportCallRequestBody: TransportCallRequestBody, options?: AxiosRequestConfig) {
        return TransportCallEntityControllerApiFp(this.configuration).patchItemResourceTransportcallPatch(id, transportCallRequestBody, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * create-transportcall
     * @param {TransportCallRequestBody} transportCallRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApi
     */
    public postCollectionResourceTransportcallPost(transportCallRequestBody: TransportCallRequestBody, options?: AxiosRequestConfig) {
        return TransportCallEntityControllerApiFp(this.configuration).postCollectionResourceTransportcallPost(transportCallRequestBody, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * update-transportcall
     * @param {string} id 
     * @param {TransportCallRequestBody} transportCallRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportCallEntityControllerApi
     */
    public putItemResourceTransportcallPut(id: string, transportCallRequestBody: TransportCallRequestBody, options?: AxiosRequestConfig) {
        return TransportCallEntityControllerApiFp(this.configuration).putItemResourceTransportcallPut(id, transportCallRequestBody, options).then((request) => request(this.axios, this.basePath));
    }
}
